#include "LedControl.h"
#include "Rotary.h"

#define SW_RESET A0

LedControl lc = LedControl(A1, A2, A3, 1);  // LED display (DIN, CLK CS, no. devices)
Rotary r = Rotary(2, 3);

int8_t enc_dir = 0;
int16_t c = 0;
bool ch_flag  = true;
// --------------------------------------------------------------------------------------------------------
void setup() {
  pinMode(SW_RESET, INPUT_PULLUP);

  attachInterrupt(0, rotary_encoder, CHANGE);
  attachInterrupt(1, rotary_encoder, CHANGE);

  lc.shutdown(0, false);                    // enable display
  lc.setIntensity(0, 10);                   // set brightness level (0 is min, 15 is max)
  lc.clearDisplay(0);                       // clear display register
}
// --------------------------------------------------------------------------------------------------------
void loop() {
  if (ch_flag) {
    ch_flag = false;
    c += enc_dir;
    if (c < 0)
      c = 9999;
    if (c > 9999)
      c = 0;
    show_count(c);
  }

  if (!digitalRead(SW_RESET)) {
    c = 0;
    show_count(c);
  }
}
// --------------------------------------------------------------------------------------------------------
void rotary_encoder() {
  uint8_t result = r.process();

  if (result) {
    ch_flag = true;
    if (result == DIR_CW)
      enc_dir = 1;
    else
      enc_dir = -1;
  }
}
// --------------------------------------------------------------------------------------------------------
void show_count(int16_t cc) {
  lc.setDigit(0, 7, cc / 1000, false);
  lc.setDigit(0, 6, (cc / 100) % 10, false);
  lc.setDigit(0, 5, (cc / 10) % 10, false);
  lc.setDigit(0, 4, cc % 10, false);
}
